Unit AMC1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure AMC1R(var N :Integer; var B :Array of Real;
                var X :Array of Real);

implementation

procedure AMC1R(var N :Integer; var B :Array of Real;
                var X :Array of Real);
var
NC,I,IS_,N2 :Integer;
G,P,Q,R,B1,B2,X1,X2 :Real;
label
_1;
begin
NC := N div 2+1;
G := 1.0/((N)*4.0);
P := 1.0;
FTF1C(B,X,N,1,1,P);
X[0] := B[0]*X[0]/N;
B[0] := 0.0;
N2 := N+2;
for I:=2 to NC do
 begin
  IS_:= N2-I;
  Q := B[I-1];
  R := B[IS_-1];
  B1 := Q+R;
  X2 := R-Q;
  Q := X[I-1];
  R := X[IS_-1];
  B2 := Q-R;
  X1 := Q+R;
  X[I-1] := (B1*X1-B2*X2)*G;
  B[I-1] := (B1*X2+X1*B2)*G;
  X[IS_-1] := X[I-1];
_1:
  B[IS_-1] := -B[I-1];
 end;
P := -1.0;
FTF1C(X,B,N,1,1,P);
end;

end.
